---
sidebar_position: 3
---

# Deployment 

## Initiale Einrichtung auf Staging/Produktivumgebung
- Sicherstellen dass [Infrastruktur](https://gitlab.cs.hs-rm.de/sls/core) läuft und erreichbar ist (Test-Executor, Keycloak)
- Repository clonen
- `.env`-Datei für [Konfiguration](backend/config.md) entsprechend anpassen. Bei Testumgebung `SUBATO2_ENV` auf `test` setzen, sonst `prod`. **Die `.env` Datei auf keinen Fall in Git einchecken!**

## Build und Deployment
Nachdem der Server eingerichtet ist, können die Images gebaut und deployed werden.

### Manuell
Siehe [Docker](docker.md). Anschließend mit `git pull && /run.sh` im Repository auf Staging/Produktivumgebung das neue Image ziehen und neu starten.

### GitLab Pipelines
GitLab Pipeline wird getriggert bei 
- Erstellung von neuem Tag (Production-Build): `SUBATO2_VER` entspricht Name des Tags
- Manueller Ausführung der Pipeline in Weboberfläche von GitLab (Dev-Build): `SUBATO2_VER` entspricht dem Schema `YYYY-MM-DD-Commithash`

Die Pipeline deployt automatisch in die entsprechende Umgebung. Dafür muss ein SSH Key in der Variable `ID_RSA` hinterlegt sein. (aktuell als Variable der `sls`-Gruppe in GitLab konfiguriert) 

## Release-Workflow
- Mit `update_version.sh <version>` an sämtlichen Stellen in der Codebase (geht leider nicht anders) die neue Version setzen und die Änderungen comitten.
- In GitLab einen neuen Tag `<version>` erstellen, [dadurch wird die Pipeline getriggert](#gitlab-pipelines), die die Images erzeugt
- Auf Testumgebung deployen und testen, anschließend auf Produktivumgebung
- Datenbank-Backups nicht vergessen!