---
sidebar_position: 2
---

# Docker
Das System kann über Docker automatisch gebaut und anschließend mit docker compose betrieben werden. Das `build.sh`-Skript ermöglicht den automatischen Build der Images und lädt diese anschließend in die Image Registry auf GitLab hoch. Artefakte (wie z.B. die .jar-Datei des Backends oder die SPA) sind dann Teil der Images.

Vor Ausführung des `build.sh`-Skripts muss die `SUBATO2_VER` Variable auf den gewünschten Tag gesetzt werden, mit dem die Images zum aktuellen Code getaggt werden sollen:

```
SUBATO2_VER=2.0.0 ./build.sh <test|prod>
``` 

* `test`: Staging-Umgebung, HTTP
* `prod`: Produktivumgebung, HTTPS

Für die SPA müssen 3 verschiedene Images (für `test`, `prod` und lokal) gebaut werden, da URLs (wie z.B das Backend) nicht dynamisch zur Laufzeit mitgegeben werden können. Die SPA wird beim Bau des Images in eine statische Webseite kompiliert, in der die URLs fest verankert sind. 

## Runner
Damit die in [Runner](backend/runner.md) beschriebenen CommandLine Runner in der Staging/Produktivumgebung ausgeführt werden können (um z.B. Semesterdaten/Stammdaten zu importieren), müssen zusätzliche `docker-compose.yml` Dateien angelegt werden. Die von den Runnern benötigten Dateien werden im Verzeichnis `.runner` organisiert und dann per Volume eingebunden.

`docker-compose.term-data.yml` stellt ein Beispiel dar, welches alle .json-Dateien im Verzeichnis `.runner/term-data` einliest und die Semesterdaten importiert. Mit `./runner.sh <core-data|term-data>` müssen die jeweiligen Runner gestartet werden. Dabei wird zunächst das aktuell laufende System heruntergefahren. Anschließend startet das Backend, führt den Runner aus und terminiert dann wieder. 

## Verwaltung der Images
Builds werden über die Docker Container Registry in GitLab verwaltet. Dev-Builds werden nach einer bestimmten Zeit bzw. nach einer bestimmten Anzahl (über GitLab Cleanup Policies) regelmäßig gelöscht. Reguläre Builds zu Versionen bleiben bestehen, bis sie manuell gelöscht werden.