import { AssessmentProgress } from "./assessment-progress";
import { Submission } from "./submission";

export class PointsAssessmentProgress extends AssessmentProgress {
    total: number;
    fullyRatedTotal: number;

    constructor(dto: any) {
        super(dto);
        this.total = dto.total;
        this.fullyRatedTotal = dto.fullyRatedTotal;
    }

    update(submissions: Submission[]): PointsAssessmentProgress {
        return new PointsAssessmentProgress({
            total: submissions.length,
            fullyRatedTotal: submissions.filter(s => s.exercise.taskInstancesCount == s.pointRatingCount).length
        });
    }

    get progress() {
        return this.total != 0 ? this.fullyRatedTotal / this.total * 100 : 100;
    }
}