import { Concept } from "./concept";
import { Ref, RefFactory} from "./ref";
import { StaticData } from "./static-data";
import { Symptom } from "./symptom";

export class Misconception {
    id: number;
    name: string;
    statement: string;
    correction: string;
    staticData: StaticData;
    concepts: Concept[];
    symptoms: Symptom[];
    refs: Ref[];

    constructor(dto: any) {
        this.id = dto.id;
        this.name = dto.name;
        this.statement = dto.statement;
        this.correction = dto.correction;
        this.staticData = new StaticData(dto.staticData);
        this.concepts = dto.concepts.map(c => new Concept(c));
        this.symptoms = dto.symptoms.map(s => new Symptom(s));
        this.refs = dto.refs.map(ref => RefFactory.create(ref));
    }
}

