import { Pipe, PipeTransform } from "@angular/core";


@Pipe({
    name: 'relativizeHeadings',
})
export class RelativizeHeadingsPipe implements PipeTransform {
    transform(inHtml: string): any {
        return this.transformHtml(inHtml);
    }

    private transformHtml(inHtml: string) {
        let parser = new DOMParser();
        let doc = parser.parseFromString(inHtml, 'text/html');
        var headings = doc.querySelectorAll("h1");
   
        headings.forEach(heading => {
            const h1Element = doc.createElement('h4');
            h1Element.innerHTML = heading.innerHTML;
            heading.parentNode.replaceChild(h1Element, heading);
        });

        return doc.body.innerHTML;
    }
}