import { NgModule } from '@angular/core';
import { Routes, RouterModule, ActivatedRouteSnapshot } from '@angular/router';
import { CourseUnit } from '../courses/models/course-unit';
import { CourseUnitComponent } from './pages/course-unit/course-unit.component';
import { ParticipantProgressComponent } from './pages/participant-progress/participant-progress.component';

export const routes: Routes = [
  {
    path: 'course/:course_id/participants/:user_id/progress',
    component: ParticipantProgressComponent,
    data: {
      reuseRoute: true,
      courseMenuEnabled: true
    }
  },
  {
    path: 'course/:course_id/myprogress',
    component: ParticipantProgressComponent,
    data: {
      reuseRoute: true,
      courseMenuEnabled: true
    }
  },
  {
    path: 'unit/:unit_id',
    component: CourseUnitComponent,
    data: {
      reuseRoute: true,
      breadcrumb: {
        alias: 'courseUnit',
        label: (unit: CourseUnit) => unit.shortName 
      },
      courseMenuEnabled: true
    }
  }
];

@NgModule({
  exports: [RouterModule]
})
export class ProgressRoutingModule { }
