import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { CourseUnitComponent } from './pages/course-unit/course-unit.component';
import { ParticipantProgressComponent } from './pages/participant-progress/participant-progress.component';
import { CoursesModule } from '../courses/courses.module';
import { ExercisesModule } from '../exercises/exercises.module';
import { AttendancesModule } from '../attendances/attendances.module';
import { SharedModule } from 'app/shared/shared.module';
import { ProgressRoutingModule } from './progress-routing.module';
import { CourseUnitParticipantSelectionComponent } from './components/course-unit-participant-selection/course-unit-participant-selection.component';
import { CourseResultTableModule } from './components/course-result-table/course-result-table.module';
import { CourseResultComponent } from './components/course-result/course-result.component';
import { BinaryAssessmentStatsComponent } from './components/binary-assessment-stats/binary-assessment-stats.component';

@NgModule({
  declarations: [
    CourseUnitParticipantSelectionComponent,
    CourseUnitComponent,
    ParticipantProgressComponent,
    BinaryAssessmentStatsComponent,
    CourseResultComponent,
  ],
  imports: [
    CommonModule,
    SharedModule,
    ProgressRoutingModule,
    CoursesModule,
    CourseResultTableModule,
    ExercisesModule,
    AttendancesModule
  ]
})
export class ProgressModule { }
