import { Component, Input, OnInit } from '@angular/core';
import { FormGroup } from '@angular/forms';
import { AppStateService } from 'app/core/services/app.state.service';
import { BaseComponent } from '../base/base.component';
import { takeUntil } from 'rxjs/operators';
import { environment } from 'environments/environment';

@Component({
  selector: 'ngx-md-editor',
  templateUrl: './md-editor.component.html',
  styleUrls: ['./md-editor.component.scss']
})
export class MdEditorComponent extends BaseComponent implements OnInit {
  @Input() controlName: string;
  @Input() form: FormGroup;
  darkMode: boolean = false;
  syntaxHighlightDocs = environment.syntaxHighlightDocs;
  
  constructor(
    private appStateService: AppStateService,
  ) { 
    super();
  }

  ngOnInit(): void {
    this.appStateService.darkMode$
    .pipe(takeUntil(this.unsubscribe))
    .subscribe(darkMode => this.darkMode = darkMode);
  }
}
