import { ParamMap } from "@angular/router";
import { BackendError } from "../models/backend-error";

export class ParamHelper {
    public static parseIdOrThrow(paramMap: ParamMap, key: string): number {
        let val = Number(paramMap.get(key));
        if(Number.isNaN(val)) {
          throw BackendError.notFound(`${key} not found in params`);
        }
    
        return val;
      }
}