import { Pipe, PipeTransform } from "@angular/core";
import { environment } from "environments/environment";

@Pipe({
    name: 'tagDownloadLinks'
})
export class TagDownloadLinksPipe implements PipeTransform {
    transform(html: string): string {
        let parser = new DOMParser();
        let doc = parser.parseFromString(html, 'text/html');
        var links = doc.querySelectorAll("a");

        links.forEach(link => {
            let href = link.attributes.getNamedItem('href').value;
            if (href.startsWith(environment.backendUrl) && href.endsWith('download')) {
                var attr = doc.createAttribute("download");
                link.attributes.setNamedItem(attr);
            }
        })

        return doc.body.innerHTML;
    }
}