package de.hsrm.sls.subato.auth.policy.courses;

import de.hsrm.sls.subato.auth.policy.CheckPolicyRequest;
import de.hsrm.sls.subato.auth.policy.PolicyRule;
import de.hsrm.sls.subato.courses.course.Course;
import org.springframework.stereotype.Component;

/**
 * The current user is allowed to view the participants of a certain course unit
 */
@Component
public class CourseViewParticipantsPolicy implements PolicyRule {
    @Override
    public boolean check(CheckPolicyRequest request) {
        if(!request.matches(CoursesAction.COURSE_VIEW_PARTICIPANTS)) {
            return false;
        }

        var course = (Course) request.getObj();
        return !request.unauthenticated() && request.getSubject().hasAnyGroup(course.getId());
    }
}
