package de.hsrm.sls.subato.search;

import de.hsrm.sls.subato.auth.policy.exercises.ExercisesAction;
import de.hsrm.sls.subato.courses.course.Course;
import de.hsrm.sls.subato.exercises.exercise.Exercise;
import de.hsrm.sls.subato.exercises.exercise.ExerciseFilter;
import de.hsrm.sls.subato.exercises.exercise.ExerciseService;
import de.hsrm.sls.subato.exercises.taskinstance.TaskInstance;
import de.hsrm.sls.subato.exercises.taskinstance.TaskInstanceFilter;
import de.hsrm.sls.subato.exercises.taskinstance.TaskInstanceService;
import de.hsrm.sls.subato.user.User;
import de.hsrm.sls.subato.user.UserFilter;
import de.hsrm.sls.subato.user.UserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class SearchService {
    @Autowired
    ExerciseService exerciseService;

    @Autowired
    TaskInstanceService taskInstanceService;

    @Autowired
    UserService userService;

    public List<TaskInstance> searchTaskInstances(Course course, String query) {
        return taskInstanceService.findAll(new TaskInstanceFilter().courseId(course.getId()).query(query));
    }

    public List<Exercise> searchExercises(Course course, String query) {
        return exerciseService.findAll(new ExerciseFilter().courseId(course.getId()).query(query), ExercisesAction.EXERCISE_VIEW);
    }

    public List<User> searchCourseParticipants(String query, Course course) {
        return userService.findAll(new UserFilter().query(query).courseId(course.getId()), userService.nameSort());
    }
}
