package de.hsrm.sls.subato.solutions.evaluation.evaluator;

import de.hsrm.sls.subato.solutions.evaluation.EvaluatorConfig;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cache.annotation.CacheEvict;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.core.ParameterizedTypeReference;
import org.springframework.http.HttpMethod;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import java.util.List;

@Service
public class EvaluatorRegistryService {
    @Autowired
    EvaluatorConfig evaluatorConfig;

    @Cacheable(value = "evaluatorRegistry")
    public List<EvaluatorEntry> getRegistry() {
        RestTemplate restTemplate = new RestTemplate();
        var url = "http://%s:%s/evaluators".formatted(evaluatorConfig.getUrl(), evaluatorConfig.getRegistryPort());
        var response = restTemplate.exchange(url, HttpMethod.GET, null, new ParameterizedTypeReference<List<EvaluatorEntry>>() {});
        return response.getBody();
    }

    @CacheEvict(value = "evaluatorRegistry")
    public void evictCache() {}
}
