package de.hsrm.sls.subato.tasks.stef.parser.meta;

import de.hsrm.sls.subato.tasks.lang.Language;
import de.hsrm.sls.subato.tasks.lang.LanguageRepository;
import de.hsrm.sls.subato.tasks.stef.spec.Meta;
import de.hsrm.sls.subato.tasks.stef.parser.InvalidSpecException;
import de.hsrm.sls.subato.tasks.stef.parser.meta.xml.TaskXml;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class LanguageExtractor {
    @Autowired
    private LanguageRepository languageRepository;

    public void extract(TaskXml doc, Meta meta) {
        Language language = null;
        if(doc.getLang() != null && !doc.getLang().equals("Unspecified") && !doc.getLang().equals("FileUpload")) {
            language = languageRepository.findByIdEqualsIgnoreCase(doc.getLang());
            if(language == null) {
                throw new InvalidSpecException("Sprache %s existiert nicht im System".formatted(doc.getLang()));
            }
        }

        meta.setLanguage(language != null ? language.getId() : null);
    }
}
