package de.hsrm.sls.subato.utils;

import de.hsrm.sls.subato.shared.config.SubatoConfig;
import org.apache.commons.io.FileUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;

import java.io.IOException;
import java.nio.file.Path;


@Component
public class PrepareSubatoDataDir {
    @Autowired
    SubatoConfig subatoConfig;

    @Value("${fixtures.dir}")
    private String fixturesDirPath;

    public void exec() {
        try {
            var dataDir = Path.of(subatoConfig.getDataDir()).toFile();
            var fixturesDir = Path.of(fixturesDirPath.replace("~", System.getProperty("user.home"))).toFile();
            FileUtils.deleteDirectory(dataDir);
            FileUtils.createParentDirectories(dataDir);
            FileUtils.copyDirectory(fixturesDir, dataDir);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

}
